//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MsgInWin.h"
#include "MsgWin.h"
#include "MBoxWin.h"
#include "FileMan.h"
#include "global.h"
#include "clipreply.h"
#include "pop3mail.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma resource "*.dfm"
TMessageInWin *MessageInWin;
//---------------------------------------------------------------------------
bool __fastcall OpenMessageIn(AnsiString &MailBox, AnsiString &IndexStr)
{
   if (MailBox.IsEmpty() || IndexStr.IsEmpty()) return false;
   MessageInWin = new TMessageInWin(MailBox,IndexStr,Application->MainForm);
   return true;
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(AnsiString &MailBox, AnsiString &Indexstr,
   TComponent* Owner) : TTextWin(Owner)
{
   Mailbox = MailBox;
   IndexStr = Indexstr;
   DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   AnsiString cap=Indexstr+" ",fs=FieldSep,ic=InCode;
 //change caption to remove markers===
   for (int i=1; i<=cap.Length(); i++)
      if (cap[i]==fs[1] || cap[i]==ic[1]) cap[i]=' ';
   cap = cap.Trim();
   while (cap.Length() && cap[cap.Length()]!=' ') cap.SetLength(cap.Length()-1);
 //=====================================================
   Caption = Mailbox+": "+cap;
   Headers = new THeaderManager(Editor->Lines);
   Editor->ReadOnly = true;
   FullHeaders = false;
   SetMessage();
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::~TMessageInWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetMessage()
{
   LockWindowUpdate(Handle);
   Editor->Clear();
   Editor->WordWrap = false;
   HeadersBtn->Hint = "Show minimum headers";
   GetAppData(Editor->Lines,DataKey);
   // handle status change
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (box) LockWindowUpdate(box->MailGrid->Handle);
//sm(DataKey);
   if (GetMsgStatus(DataKey)=='N') SetMsgStatus(DataKey,' ');
//sm(DataKey);
   if (box) LockWindowUpdate(0);
   // check for special header treatment
   if (NoHeaders->Checked)
   {
      while (!Headers->PopHeader().IsEmpty()) Application->ProcessMessages();
      Editor->Lines->Delete(0);
   }
   else
   if (!FullHeaders)
   {
      HeadersBtn->Hint = "Show all message headers";
      TStringList *msghdrs = new TStringList();
      msghdrs->Add("Date: ");
      msghdrs->Add("From: ");
      msghdrs->Add("Comments: ");
      msghdrs->Add("To: ");
      msghdrs->Add("Cc: ");
      msghdrs->Add("Subject: ");

      AnsiString mdr,hdr;
      TStringList *hdrs = new TStringList();
      for (int i=msghdrs->Count-1; i>=0; i--)
      {
         mdr = msghdrs->Strings[i]; // get as many of each as exists
         while (!(hdr=Headers->GetDat(mdr)).IsEmpty()) // thinking mostly of 'From: '
         {
            if (mdr.Pos("Subject: ")==1 && hdr.IsEmpty()) hdr = "Re:";
            hdrs->Insert(0,mdr+hdr);
            Headers->Delete(mdr);
         }
      }
      while (!Headers->PopHeader().IsEmpty()) Application->ProcessMessages();
      Editor->Lines->Delete(0);
      Editor->Lines->Insert(0,hdrs->Text);
      delete hdrs;
   }
   Editor->Modified = false;
   Editor->SelStart = 0;
   LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
int eohm(TStrings *msg)
{
   int e=0; while (e<msg->Count && !msg->Strings[e].IsEmpty()) e++;
   return e;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::CreateReply(bool UseDialog)
{
   AnsiString TemplateName=DefaultMessage,inreplyto;
   if (UseDialog && (TemplateName=GetMergeMessage(modeMessage)).IsEmpty()) return;
   if (GetMsgStatus(DataKey)==' ')
   {
      SetMsgStatus(DataKey,'R');
      inreplyto = DataKey;
   }
   ReplyToMessage(Editor->Lines,TemplateName,inreplyto);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::HeadersBtnClick(TObject *Sender)
{
   if (EditBtn->Down)
   {
      HeadersBtn->Down = true;
      return;
   }
   FullHeaders = HeadersBtn->Down;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::ReplyBtnClick(TObject *Sender)
{
   CreateReply(true);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,"Save changes to message?",
         "Save Message",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified && !CheckSave())
   {
      CanClose = false;
      return;
   }
   if (MDIChildCount==0) SetParentButtons(false);
   ShowCurXY(false);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::Save()
{
//PutAppData(UserMailboxes+PS+Mailbox+PS+IndexStr,Editor->Lines);
//sm(DataKey);
//sm(Editor->Lines->Text);
   PutAppData(DataKey,Editor->Lines);
   Editor->Modified = false;

//TStringList *tmp = new TStringList();
//   GetAppData(tmp,DataKey);
//sm(tmp->Text);
//   delete tmp;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::OkBtnClick(TObject *Sender)
{
//   if (!Editor->Modified || (Editor->Modified && Save()))
      Close();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::WordWrapClick(TObject *Sender)
{
   Editor->WordWrap = WordWrap->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::EditBtnClick(TObject *Sender)
{
   SetEditMode(EditBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::NoHeadersClick(TObject *Sender)
{
   if (NoHeaders->Checked) HeadersBtn->Visible = false;
   else HeadersBtn->Visible = true;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetEditMode(bool Editing)
{
   if (Editing)
   {
      Editor->ReadOnly = false;
      ReplyBtn->Enabled = false;
      NoHeaders->Checked = false;
      NoHeaders->Enabled = false;
      WordWrap->Checked = false;
      WordWrap->Enabled = false;
      HeadersBtn->Down = true;
      FullHeaders = true;
      SetMessage();
   }
   else
   {
      if (!CheckSave())
      {
         EditBtn->Down = true;
         return;
      }
      SetMessage();
      Editor->ReadOnly = true;
      NoHeaders->Enabled = true;
      WordWrap->Enabled = true;
      ReplyBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------