#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MsgWin.h"
#include "MsgInWin.h"
#include "SaveDlg.h"
#include "HttpDlg.h"
#include "SmtpDlg.h"
#include "QueueDlg.h"
#include "Version.h"
#include "Mixmaster.h"
#include "MixmastDlg.h"
#include "DelGrpsDlg.h"
#include "mboxwin.h"
// pgp stuff
#include "PassDlg.h"
#include "PGPpass.h"
#include "PGPrecip.h"

//const bool NoDialog = false;
const AnsiString Drafts = "Messages";
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma resource "*.dfm"
TMessageWin *MessageWin;
//---------------------------------------------------------------------------
bool __fastcall OpenMessage(AnsiString &Mailbox, AnsiString &IndexStr)
{
   if (Mailbox.IsEmpty() || IndexStr.IsEmpty()) return false;
   AnsiString DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   TStringList *msg = new TStringList();
   GetAppData(msg,DataKey);
   MessageWin = new TMessageWin(msg,Mailbox,IndexStr,Application->MainForm);
   MessageWin->DataKey = DataKey;
   delete msg;
   return true;
}
//---------------------------------------------------------------------------
char __fastcall GetMsgStatus(AnsiString &DataKey)
{
   if (DataKey.Pos(UserMailboxes)!=1) return '\0';

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr = GetParam(2,DataKey,PS.c_str());
   if (IndexStr==HeaderText) return GetParam(3,IndexStr," ").SubString(1,1)[1];

   if (!IsNewStyle(DataKey)) return 'S';  // only outgoing is old style
   char status=IndexStr.SubString(24,1)[1];
   if (status=='i') return ' ';
   if (status=='o') return 'S';
   return status;
}
//---------------------------------------------------------------------------
bool __fastcall SetMsgStatus(AnsiString &DataKey, char status)
{
   if (DataKey.Pos(UserMailboxes)!=1) return false;

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr = GetParam(2,DataKey,PS.c_str());
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   //if (box) LockWindowUpdate(box->MailGrid->Handle);
   if (IndexStr.Length()>=24)
   {
      IndexStr[24] = status;
      RenameAppItem(DataKey,IndexStr);
      if (box) box->MailGrid->RefreshIndex();
      DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   }
   //if (box) LockWindowUpdate(0);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall IsNewStyle(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return idxstr.SubString(23,1)==InCode || idxstr.SubString(23,1)==OutCode;
}
//---------------------------------------------------------------------------
bool __fastcall IsIncoming(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return IsNewStyle(DataKey) && idxstr.SubString(23,1)==InCode;
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TComponent* Owner) : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TStrings* Message, AnsiString &mailbox,
   AnsiString &indexstr, TComponent* Owner) : TTextWin(Owner)
{
   Mailbox = mailbox;
   IndexStr = indexstr;
   DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   Headers = new THeaderManager(Editor->Lines);
   Editor->Lines->Text = Message->Text;
   SetMessage();
   PgpHeaderToButtons();
   PGPencBtn->Visible = PGPsigBtn->Visible = PGPnowBtn->Visible = false;
   if (FileExists(HomeVarsText))
   {
      PGPencBtn->Visible = PGPsigBtn->Visible = PGPnowBtn->Visible = true;
      TStringList *dat = new TStringList();
      dat->LoadFromFile(HomeVarsText);
      PGPsecringPath = dat->Values["SECRING"];
      PGPpubringPath = dat->Values["PUBRING"];
      delete dat;
   }
   MessageSent = false;
   Type = tNewMessage;
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::~TMessageWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::UpdateStatsOnSend()
{
   return Application->MainForm->Perform(WM_UPDATECHECKED,0,NULL)>0;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewMessage()
{
   LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultMessage); SetCursor();
   PgpHeaderToButtons();
   Editor->Modified = false;
   Caption = newMessage;
   SetCursor();
   Type = tNewMessage;
   LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewArticle()
{
   LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultArticle); SetCursor();
   PgpHeaderToButtons();
   Editor->Modified = false;
   Caption = newArticle;
   SetCursor();
   Type = tNewArticle;
   LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetCursor()
{
   Editor->SelStart = 0;
   TStrings *msg = Editor->Lines;
   int pos,eoh = msg->Text.Pos("\r\n\r\n");
   if (eoh==0) eoh = msg->Text.Length();
   if ((pos=msg->Text.Pos(": \r\n"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   if (!pos && (pos=msg->Text.Pos(": ;"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   {
      Editor->SelStart = eoh;
      if (eoh < msg->Text.Length())
         Editor->SelStart = Editor->SelStart+4;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefMessage()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   if (ButtonsToPgpHeader(pgp)) Editor->Lines->Insert(0,pgp);
   if (PutAppData(DefaultMessage,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewMessage();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefArticle()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   if (ButtonsToPgpHeader(pgp)) Editor->Lines->Insert(0,pgp);
   if (PutAppData(DefaultArticle,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewArticle();
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Save()
{
   if (Name().IsEmpty()) return SaveAs();

   AnsiString path,spath,pgphdr;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text; Editor->Clear();
   LockWindowUpdate(Handle);
//   if (ButtonsToPgpHeader(pgphdr)) lines->Insert(0,pgphdr);
   PutAppData(DataKey,lines);
//   if (pgphdr.Length()) lines->Delete(0);
   Editor->Lines->Text = lines->Text;
   Editor->SelStart = 0;
   Editor->Modified = false;
   SetCursor();
   Sleep(100);
   LockWindowUpdate(0);
   AnsiString shomsg = Caption+" ... saved!";
   Application->MainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)shomsg.c_str());
//   MyBeep(MB_OK);
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAs()
{
   bool ok=false;
   AnsiString name,pgphdr;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text; Editor->Clear();
//   if (ButtonsToPgpHeader(pgphdr)) lines->Insert(0,pgphdr);
   name = SaveMessage(lines,UserMessages,Name());
   if (!name.IsEmpty())
   {
      DataKey = UserMessages+PS+name;
      GetAppData(Editor->Lines,DataKey);
//      if (pgphdr.Length()) Editor->Lines->Delete(0);
      Mailbox = Drafts; IndexStr = name;
      Type = tMessage;
      SetMessage();
      ok = true;
   }
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAsTemplate()
{
   bool ok=false;
   AnsiString name,pgphdr;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text; Editor->Clear();
//   if (ButtonsToPgpHeader(pgphdr)) lines->Insert(0,pgphdr);
   name = SaveMessage(lines,UserTemplates,Name());
   if (!name.IsEmpty())
   {
      DataKey = UserTemplates+PS+name;
      GetAppData(Editor->Lines,DataKey);
//      if (pgphdr.Length()) Editor->Lines->Delete(0);
      Mailbox = "Template"; IndexStr = name;
      Type = tTemplate;
      SetMessage();
      ok = true;
   }
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      switch (MsgBox("Your message is modified. Changes will be lost!\n\nQueue it now?",
                 "Queue Message",MB_YESNOCANCEL))
      {
         case mrYes:
            if (!Queue()) return false;
            // fall through
         case mrNo:
            Editor->Modified = false;
            Close();
            break;
         case mrCancel:
            ok = false;
            break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckValid()
{
   AnsiString fcc;
   if (!ValidMail())
   {
      // maybe they fcc'd to mailbox "User Mailboxes"--no good
      if ((fcc=Headers->GetDat("Fcc: "))==UserMailboxes)
      {
         MsgBox(
            AnsiString("\""+fcc+"\"is not a valid mailbox name!\n\n")+
            AnsiString("Please choose another."),
           "Message Error",
            MB_OK
         );
         return false;
      }
      // missing header info that is required
      MsgBox(
         AnsiString("Valid entries are required for 'Host', 'From'\n")+
         AnsiString("and 'To' headers."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   if (HeadMan->Has("Chain: ",Editor->Lines) && !RegKeyExists(MixKey))
   {
      MsgBox(
         AnsiString("Message contains a 'Chain:' header, but\n")+
         AnsiString("Mixmaster is not installed!\n\n")+
         AnsiString("Please remove the 'Chain:' header."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ValidMail()
{
   AnsiString host,from,rcpt,fcc;
   host = Headers->GetDat("Host: ",Editor->Lines);
   from = Headers->GetDat("From: ");
   rcpt = Headers->GetDat("To: ");
   fcc  = Headers->GetDat("Fcc: ");
   bool ok = !(host=="" ||
               from=="" || from.Pos("@")<2 ||
               rcpt=="" || rcpt.Pos("@")<2 ||
               fcc.Pos(PS)>=2
   );
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Name()
{
//   AnsiString name;
//   if (Caption!=newMessage && Caption!=newArticle)
//      name = Caption.SubString(Caption.Pos(": ")+2,255);
//   return name;
   return IndexStr;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Section()
{
//   AnsiString section;
//   if (Caption!=newMessage && Caption!=newArticle)
//      section = Caption.SubString(1,Caption.Pos(":")-1);
//   return section;
   return Mailbox;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetMessage()
{
   Editor->OnSelectionChange = NULL;
   AnsiString cap=IndexStr+" ",fs=FieldSep,oc=OutCode;
// change caption to remove markers ===============
   if (cap.Pos(InCode)>0 || cap.Pos(OutCode)>0)
   {
      for (int i=1; i<=cap.Length(); i++)
         if (cap[i]==fs[1] || cap[i]==oc[1]) cap[i]=' ';
      cap = cap.Trim();
      while (cap.Length() && cap[cap.Length()]!=' ')
         cap.SetLength(cap.Length()-1);
   }
//=================================================
   if (Mailbox.IsEmpty() && cap.Trim().IsEmpty())
      Caption = Headers->Get("Newsgroups: ").IsEmpty() ? newMessage:newArticle;
   else
      Caption = Mailbox+": "+cap;

   Editor->Modified = false;
   Editor->SelStart = 0;

   if (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)!="#")
      SetCursor();

   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckMailQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(MailQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the Mail Queue.\n\n")+
         AnsiString("Take a look, now?"),"Queued Mail",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENQUEUE,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckProblemsQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(ProblemQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the PROBLEM Queue.\n\n")+
         AnsiString("Take a look, now?"),"Previous Problems",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENPROBLEMS,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckWhiteEOH()
{
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i];
      if (s.IsEmpty()) break;
      if (s.Length() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckOver80Chars()
{
   bool ok = true;
   TStringList *hold = new TStringList();
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i]; if (s.IsEmpty()) break;
      if (s.Length()<=80) { hold->Add(s); continue; }
      Editor->SelStart = hold->Text.Length();
      Editor->Perform(EM_SCROLLCARET,0,0);
      Application->ProcessMessages();
      MsgBox(
         AnsiString("  You have a header that's too long. Mixmaster allows only 80  \n")+
         AnsiString("  characters. You can probably break the header and continue it  \n")+
         AnsiString("  on the next line. I'll placed the cursor at the beginning of the\n")+
         AnsiString("  problem header. When breaking the header, make sure each  \n")+
         AnsiString("  continued line is indented with a space or a tab. \n")+
         AnsiString("\n\n"),
        "Header Length Error",
         MB_OK
      );
      ok = false;
      break;
   }
   delete hold;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckReferences()
{
   int pos;
   if (!HeadMan->Has("Chain: ",Editor->Lines)) return;

   AnsiString refs = HeadMan->GetReferences();
   while (references.Length()+refs.Length() > 80)
   {
      if ((pos=refs.Pos(">"))==0) break;
      refs = refs.SubString(pos+2,1024);
   }
//   while ((pos=refs.Pos("> <"))>0) refs.Insert("\r\n",pos+1);
//   Editor->Lines->Insert(HeadMan->Delete(references),references+refs);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckNewsgroups()
{
   int pos;
   bool ok = true;
   if (!HeadMan->Has("Chain: ",Editor->Lines)) return ok;

   AnsiString grps = HeadMan->GetNewsgroups();
   if (newsgroups.Length()+grps.Length() > 80)
   {
      if ((ok=MassageNewsgroups(grps,this))==true)
      {
         pos=0; while(++pos<grps.Length()-1)
            if (grps[pos]==',') grps.Insert("\r\n ",pos+1);
         Editor->Lines->Insert(HeadMan->Delete(newsgroups),newsgroups+grps);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Queue(bool UseDialog)
{
   CheckWhiteEOH();
   if (Limit80Chars && HeadMan->Has("Chain: ",Editor->Lines))
   {
      if (!CheckOver80Chars() || !CheckNewsgroups()) return false;
     //CheckReferences();
   }
   if (CheckValid())
   {
      if ((PGPencBtn->Down || PGPsigBtn->Down) && !HandlePGP())
         return false;
      if (QueueMessage(Editor->Lines,UseDialog))
      {
         Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
         Editor->Modified = false;
         if (UseDialog) {
           Sleep(200); Close();
         }
         return true;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Send()
{
   if (CheckProblemsQueue()) return false;
   if (UpdateStatsOnSend())
   {
      AnsiString chain=HeadMan->GetDat("Chain: ",Editor->Lines);
      if (!chain.Pos("*"))  // turn off updating when no random present
         Application->MainForm->Perform(WM_UPDATEENABLE,0,NULL);
      else
      {
         if (!GetRemailerStats(Application->MainForm,false))
            return false;
         Application->ProcessMessages();
         Sleep(500);
      }
   }
   if (Queue(!UseDialog))
   {
      // Send a message to the mainform letting it take
      // control--close this window, set a timer, wait, open smtpdlg
      PostMessage(Application->MainForm->Handle,WM_SENDMAIL,0,(LPARAM)this);
      MessageSent = true;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::QueueBtnClick(TObject *Sender)
{
   Queue();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnClick(TObject *Sender)
{
   Send();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormResize(TObject *Sender)
{
   SetEditRect();
   PGPencBtn->Left = Panel1->Width - 82;
   PGPsigBtn->Left = PGPencBtn->Left + 26;
   PGPnowBtn->Left = PGPsigBtn->Left + 26;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormShow(TObject *Sender)
{
   PGPnowBtn->Enabled = PGPsigBtn->Down || PGPencBtn->Down;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
// PGP stuff
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPencBtnClick(TObject *Sender)
{
   if (PGPencBtn->Down || PGPsigBtn->Down) PGPnowBtn->Enabled = true;
   else PGPnowBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPsigBtnClick(TObject *Sender)
{
   if (PGPencBtn->Down || PGPsigBtn->Down) PGPnowBtn->Enabled = true;
   else PGPnowBtn->Enabled = false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandlePGP()
{
   bool ok=false;
   if (PGPencBtn->Down && PGPsigBtn->Down) ok=EncryptSignMessage(); else
   if (PGPencBtn->Down) ok=EncryptMessage(); else
   if (PGPsigBtn->Down) ok=SignMessage();

   PGPnowBtn->Enabled = false;
   PGPencBtn->Down = false;
   PGPsigBtn->Down = false;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPnowBtnClick(TObject *Sender)
{
   HandlePGP();
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ButtonsToPgpHeader(AnsiString &PgpHeader)
{
   AnsiString pgp;
   if (PGPencBtn->Down && PGPsigBtn->Down) pgp = "encrypt,sign"; else
   if (PGPencBtn->Down) pgp = "encrypt"; else
   if (PGPsigBtn->Down) pgp = "sign";
   if (pgp.Length())
   {
      //Editor->Lines->Insert(0,"Pgp: "+pgp);
      PgpHeader = "Pgp: "+pgp;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::PgpHeaderToButtons()
{
   AnsiString pgp=Editor->Lines->Strings[0];
   if (pgp.Pos("Pgp: ")==1)
   {
      PGPencBtn->Down = pgp.Pos("encrypt");
      PGPsigBtn->Down = pgp.Pos("sign");
      Editor->Lines->Delete(0);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::EncryptSignMessage()
{
   TStringList *recips = new TStringList();
   AnsiString encryptto = Headers->GetDat(EncryptTo,Editor->Lines);
   if (!encryptto.IsEmpty())
   {
      Headers->GetAddresses(recips,encryptto);
      Headers->Delete(EncryptTo);
   }
   else
   {
      Headers->GetRecipients(recips);
      if (!PGPgetEncryptList(recips))
      {
         delete recips;
         return false;
      }
   }
   int first,last;
   AnsiString keyid;
   bool cEncrypt=false;
   TDataBuf *passphrase = new TDataBuf();
   if (recips->Count && recips->Strings[0]==UseConventional)
   {
      if (GetUserPassphrase(mdConventional,passphrase)!=mrOk)
      {
         delete passphrase;
         delete recips;
         return false;
      }
      cEncrypt = true;
   }
   else
   {
      keyid=Headers->GetDat("From: ",Editor->Lines);
      if (!PGPgetKeynameAndPassPhrase(keyid,passphrase))
      {
         delete passphrase;
         delete recips;
         return false;
      }
      first=keyid.Pos("<"); last=keyid.Pos(">");
      keyid = keyid.SubString(first?first:1,last?last-(first-1):keyid.Length());
   }

   int mrResult = mrCancel;
   TStrings *msg = Editor->Lines;
   last=-1,first=0;
   while (!msg->Strings[first].IsEmpty()) first++;
   for (int i=msg->Count-1; i>0; i--)
   {
      if (msg->Strings[i].Trim()==CutMarks)
      {
         last = i-1;
         break;
      }
   }
   if (last<0) last = msg->Count-1;
   if (last>0)
   {
      TStringList *mail = new TStringList();
      for (int i=first+1; i<=last; i++) mail->Add(msg->Strings[i]);
      if (cEncrypt)
      {
         mrResult = PgpEncryptConventional(mail,passphrase);
      }
      else
      {
         mrResult = PgpEncryptSignMessage(mail,recips,keyid,passphrase,
            PGPpubringPath,PGPsecringPath);
      }
      if (mrResult==mrOk)
      {
         for (int i=0; i<=first; i++)
            mail->Insert(i,msg->Strings[i]);
         for (int i=last+1; i<msg->Count; i++)
            mail->Add(msg->Strings[i]);
         LockWindowUpdate(Handle);
         Editor->SelectAll();
         Editor->SelText = mail->Text;
         Editor->SelStart = 0;
         LockWindowUpdate(0);
      }
      delete mail;
   }
   else
      MsgBoxHwnd(Handle,"Nothing to sign!","PGP Sign Error",MB_OK);
   delete recips;
   return mrResult==mrOk; // temporary for debug
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::EncryptMessage()
{
   TStringList *recips = new TStringList();
   AnsiString encryptto = Headers->GetDat(EncryptTo,Editor->Lines);
   if (!encryptto.IsEmpty())
   {
      Headers->GetAddresses(recips,encryptto);
      Headers->Delete(EncryptTo);
   }
   else
   {
      Headers->GetRecipients(recips,Editor->Lines);
      if (!PGPgetEncryptList(recips))
      {
         delete recips;
         return false;
      }
   }
   bool cEncrypt;
   TDataBuf *passphrase = new TDataBuf();
   if (recips->Count && recips->Strings[0]==UseConventional)
   {
      if (GetUserPassphrase(mdConventional,passphrase)!=mrOk)
      {
         delete passphrase;
         delete recips;
         return false;
      }
      cEncrypt = true;
   }

   int last=-1,first=0,mrResult=mrOk;
   TStrings *msg = Editor->Lines;
   while (!msg->Strings[first].IsEmpty()) first++;
   for (int i=msg->Count-1; i>0; i--)
      if (msg->Strings[i].Trim()==CutMarks)
      {
         last = i-1;
         break;
      }
   if (last<0) last = msg->Count-1;
   if (last>0)
   {
      TStringList *mail = new TStringList();
      for (int i=first+1; i<=last; i++) mail->Add(msg->Strings[i]);
      if (!cEncrypt)
      {
         mrResult = PgpEncryptMessage(mail,recips,PGPpubringPath);
      }
      else
      {
         mrResult = PgpEncryptConventional(mail,passphrase);
      }
      if (mrResult==mrOk)
      {
         for (int i=0; i<=first; i++)
            mail->Insert(i,msg->Strings[i]);
         for (int i=last+1; i<msg->Count; i++)
            mail->Add(msg->Strings[i]);
         LockWindowUpdate(Handle);
         Editor->SelectAll();//SelStart = 0; Editor->SelLength = Editor->Text.Length();
         Editor->SelText = mail->Text;
         //Editor->Lines->Text = mail->Text;
         Editor->SelStart = 0;
         LockWindowUpdate(0);
      }
      delete mail;
   }
   else
      MsgBoxHwnd(Handle,"Nothing to encrypt!","PGP Sign Error",MB_OK);

   delete passphrase;
   delete recips;
   return mrResult==mrCancel;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SignMessage()
{
   TDataBuf *passphrase = new TDataBuf();
   AnsiString keyid=Headers->GetDat("From: ",Editor->Lines);
   if (!PGPgetKeynameAndPassPhrase(keyid,passphrase))
   {
      delete passphrase;
      return false;
   }

   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1,mrResult=mrCancel;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());
   last=-1;
   TStrings *msg = Editor->Lines;
   for (int i=msg->Count-1; i>0; i--)
      if (msg->Strings[i].Trim()==CutMarks)
      {
         last = i-1;
         break;
      }
   if (last<0) last = msg->Count-1;
   if (last>0)
   {
      TStringList *mail = new TStringList();
      for (int i=0; i<=last; i++) mail->Add(msg->Strings[i]);
      mrResult = PgpSignMessage(mail,passphrase,keyid,PGPsecringPath);
      if (mrResult==mrOk)
      {
         for (int i=last+1; i<msg->Count; i++)
            mail->Add(msg->Strings[i]);
         LockWindowUpdate(Handle);
         Editor->SelectAll();
         Editor->SelText = mail->Text;
         Editor->SelStart = 0;
         LockWindowUpdate(0);
      }
      delete mail;
   }
   else
      MsgBoxHwnd(Handle,"Nothing to sign!","PGP Sign Error",MB_OK);
   delete passphrase;
   return mrResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   TTextWin::FormCloseQuery(Sender,CanClose);
   if (!CanClose) return;

   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (box) LockWindowUpdate(box->MailGrid->Handle);
   if (!MessageSent && !InReplyTo.IsEmpty()) SetMsgStatus(InReplyTo,' ');
   if (box) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
