//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "NoteWin.h"
#include "SaveDlg.h"
#include "FileMan.h"
#include "PrintDlg.h"
#include "Global.h"
#include "mixmaster.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TTextWin *TextWin;
//---------------------------------------------------------------------------
/*TTextWin* __fastcall NewTextWin(const AnsiString &Title, TStrings *Lines)
{
   TextWin = new TTextWin(Application->MainForm);
   TextWin->Caption = Title;
   TextWin->Editor->Lines->Text = Lines->Text;
   TextWin->Editor->Modified = false;
   return TextWin;
}*/
//---------------------------------------------------------------------------
__fastcall TTextWin::TTextWin(TComponent* Owner) : TForm(Owner)
{
   Editor->Font->Name = GetAppIni("FontName","Courier New");
   Editor->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   EditWordWrapItem->Checked = GetAppIni("WordWrap","").ToIntDef(1);
   Editor->WordWrap = EditWordWrapItem->Checked;
   Type = tNewNote;
}
//---------------------------------------------------------------------------
/*__fastcall TTextWin::TTextWin(TComponent* Owner, TStrings *Text, AnsiString &Title)
  : TForm(Owner)
{
   Editor->Font->Name = GetAppIni("FontName","Courier New");
   Editor->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   EditWordWrapItem->Checked = GetAppIni("WordWrap","").ToIntDef(1);
   Editor->WordWrap = EditWordWrapItem->Checked;
   Editor->Lines->Text = Text->Text;
   Caption = Title;
}*/
//---------------------------------------------------------------------------
bool __fastcall TTextWin::Save()
{
   if (!Name().IsEmpty())
   {
      DataKey = UserNotes+PS+Name();
      PutAppData(DataKey,Editor->Lines);
      Editor->Modified = false;
      return true;
   }
   return SaveAs();
}
//---------------------------------------------------------------------------
bool __fastcall TTextWin::SaveAs()
{
   AnsiString name = SaveMessage(TextWin->Editor->Lines,UserNotes,TextWin->Name());
   if (!name.IsEmpty())
   {
    //message is actually saved in SaveMessage
      DataKey = UserNotes+PS+name;
      TStringList *txt = new TStringList();
      Editor->Clear(); Sleep(SleepTime);
      GetAppData(txt,DataKey);
      TextWin->SetText(name,txt);
      Editor->Modified = false;
      delete txt;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TTextWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,
            "Your note is modified. Changes will be lost!\n\nSave it now?",
               "Save Note",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::EditMenuClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))!=NULL)
   {
      if (item->Caption=="&Edit") {
         bool hasSel = Editor->SelLength > 0;
         EditUndoItem->Enabled = Editor->Modified;
         EditCutItem->Enabled = hasSel;
         EditCopyItem->Enabled = hasSel;
         EditPasteItem->Enabled = Clipboard()->HasFormat(CF_TEXT);
         EditPasteAsQuoteItem->Enabled = EditPasteItem->Enabled;
         EditSelectAllItem->Enabled = Editor->Lines->Count > 0;
      }
      else
      if (item->Caption=="&Undo") Editor->Perform(WM_UNDO,0,NULL); else
      if (item->Caption=="Cu&t") Editor->CutToClipboard(); else
      if (item->Caption=="&Copy") Editor->CopyToClipboard(); else
      if (item->Caption=="Select &All") Editor->SelectAll(); else
      if (item->Caption=="&Paste") PasteFromClipboard(Editor); else // <-in global
      if (item->Caption=="Paste as &Quotation") PasteFromClipboardQuote(); else
      if (item->Caption=="&Word Wrap")
      {
         LockWindowUpdate(Handle);
         EditWordWrapItem->Checked = !EditWordWrapItem->Checked;
         Editor->WordWrap = EditWordWrapItem->Checked;
         LockWindowUpdate(0);
         PutAppIni("WordWrap",Editor->WordWrap?"1":"0");
      }
      else
      if (item->Caption=="Insert &Filename...")
         Application->MainForm->Perform(WM_INSERTFILENAME,0,NULL);
   }
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::PopupMenuClick(TObject *Sender)
{
   TMenuItem *item;
 //TPopupMenu *menu;
   if (dynamic_cast<TPopupMenu*>(Sender)!=NULL)
   {
      bool hasSel = Editor->SelLength > 0;
      PopUndoItem->Enabled = Editor->Modified;
      PopCutItem->Enabled = hasSel;
      PopCopyItem->Enabled = hasSel;
      PopPasteItem->Enabled = Clipboard()->HasFormat(CF_TEXT);
      PopPasteAsQuoteItem->Enabled = EditPasteItem->Enabled;
      PopSelectAllItem->Enabled = Editor->Lines->Count > 0;
      PopWordWrapItem->Checked = Editor->WordWrap;
   }
   else
   if ((item=dynamic_cast<TMenuItem*>(Sender))!=NULL)
   {
      if (item->Caption=="&Undo") Editor->Perform(WM_UNDO,0,NULL); else
      if (item->Caption=="Cu&t") Editor->CutToClipboard(); else
      if (item->Caption=="&Copy") Editor->CopyToClipboard(); else
      if (item->Caption=="Select &All") Editor->SelectAll(); else
      if (item->Caption=="&Paste") PasteFromClipboard(Editor); else // <-in global
      if (item->Caption=="Paste as &Quotation") PasteFromClipboardQuote(); else
      if (item->Caption=="&Word Wrap")
      {
         LockWindowUpdate(Handle);
         PopWordWrapItem->Checked = !PopWordWrapItem->Checked;
         EditWordWrapItem->Checked = PopWordWrapItem->Checked;
         Editor->WordWrap = EditWordWrapItem->Checked;
         PutAppIni("WordWrap",Editor->WordWrap?"1":"0");
         LockWindowUpdate(0);
      }
      else
      if (item->Caption=="Insert &Filename...")
         Application->MainForm->Perform(WM_INSERTFILENAME,0,NULL);
   }
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::ShowCurXY(bool DontClear)
{
//   if (loading) return;
   if (!DontClear)
      Application->MainForm->Perform(WM_DISPLAYXY,-1,-1);
   else
   {
      long sel=Editor->SelStart;
      int linenum = Editor->Perform(EM_EXLINEFROMCHAR,0,(LPARAM)(DWORD)sel);
      int linepos = Editor->Perform(EM_LINEINDEX,linenum,0L);
      Application->MainForm->Perform(WM_DISPLAYXY,sel-linepos+1,linenum+1);
   }
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified && !CheckSave())
   {
      CanClose = false;
      return;
   }
   if (MDIChildCount==0) SetParentButtons(false);
   ShowCurXY(false);
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormActivate(TObject *Sender)
{
   SetParentButtons(true);
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormDeactivate(TObject *Sender)
{
   SetParentButtons(false);
   ShowCurXY(false);
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::EditorSelectionChange(TObject *Sender)
{
   SetParentButtons(true);
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::OkBtnClick(TObject *Sender)
{
   if (!Editor->Modified || (Editor->Modified && Save()))
      Close();
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::Print()
{
   if (MsgBoxHwnd(Handle,"Print window contents now?","Printer",MB_OKCANCEL)==IDOK)
      PrintMessage(Editor->Lines,Editor->Font,"Print Message");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TTextWin::Name()
{
//   AnsiString name;
//   if (Caption!=newNote)
//      name = Caption.SubString(AnsiString("Note - ").Length()+1,255);
//   return name;
   return IndexStr;
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::SetText(AnsiString &Name, TStrings *Text)
{
   IndexStr = Name;
   DataKey = UserNotes+PS+Name;
   Caption = UserNotes+": "+Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::SetParentButtons(bool enable)
{
   Application->MainForm->Perform(WM_SETBUTTONS,enable,Editor->SelLength);
}
//----------------------------------------------------------------------------
void __fastcall TTextWin::SetEditRect()
{
   TRect Rct = Rect(4,0,Editor->ClientWidth-8,ClientHeight);
   SendMessage(Editor->Handle,EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormResize(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormPaint(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::EditorMouseMove(TObject *Sender, TShiftState Shift,
  int X, int Y)
{
   rnd_mouse(WM_MOUSEMOVE,0,MAKELONG(X,Y));
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::PasteFromClipboardQuote()
{
   AnsiString s;
   TMemo *m = new TMemo((void*)NULL);
   m->WordWrap = false;
   m->Visible = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();

   for (int i=0; i<m->Lines->Count; i++)
      m->Lines->Strings[i] = QteMarks+m->Lines->Strings[i];
   Editor->SelText = m->Lines->Text;
   SetEditRect();
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall TTextWin::FormShow(TObject *Sender)
{
//   loading = false;
}
//---------------------------------------------------------------------------
