//---------------------------------------------------------------------------
#ifndef NoteWinH
#define NoteWinH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
const AnsiString newNote = "New Note";
enum MsgType { tNewMessage,tNewArticle,tNewNote,tMessage,tArticle,tNote,tTemplate };

class TTextWin : public TForm
{
__published:	// IDE-managed Components
  TMenuItem *N1;
  TMenuItem *N3;
  TPanel *Panel1;
  TRichEdit *Editor;
  TSpeedButton *OkBtn;
  TMainMenu *MainMenu;
  TMenuItem *EditMenu;
  TMenuItem *EditUndoItem;
  TMenuItem *EditCutItem;
  TMenuItem *EditCopyItem;
  TMenuItem *EditPasteItem;
  TMenuItem *EditSelectAllItem;
  TMenuItem *EditWordWrapItem;
  TMenuItem *EditInsertTextFromFileItem;
  TMenuItem *EditInsertFilenameItem;
  TMenuItem *EditPasteAsQuoteItem;
  TMenuItem *N2;
  TPopupMenu *PopupMenu;
  TMenuItem *PopCutItem;
  TMenuItem *PopUndoItem;
  TMenuItem *N4;
  TMenuItem *PopCopyItem;
  TMenuItem *PopPasteItem;
  TMenuItem *PopSelectAllItem;
  TMenuItem *PopPasteAsQuoteItem;
  TMenuItem *N5;
  TMenuItem *PopInsertFilenameItem;
  TMenuItem *PopInsertTextItem;
  TMenuItem *N6;
  TMenuItem *PopWordWrapItem;
  void __fastcall EditMenuClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall FormDeactivate(TObject *Sender);
  void __fastcall EditorSelectionChange(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall FormPaint(TObject *Sender);
  void __fastcall EditorMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall PopupMenuClick(TObject *Sender);
private:	// User declarations
public:	// User declarations
  bool loading;
  MsgType Type;
  AnsiString DataKey,IndexStr;
  __fastcall virtual TTextWin(TComponent* Owner);
  //__fastcall virtual TTextWin(TComponent* Owner, TStrings *Text, AnsiString &Title);
  virtual AnsiString __fastcall Name();
  void __fastcall SetEditRect();
  void __fastcall SetText(AnsiString &Name, TStrings *Text);
  void __fastcall SetParentButtons(bool enable);
  void __fastcall PasteFromClipboardQuote();
  virtual bool __fastcall CheckSave();
  virtual bool __fastcall SaveAs();
  virtual bool __fastcall Save();
  void __fastcall Print();
  void __fastcall ShowCurXY(bool DontClear);
};

TTextWin* __fastcall NewTextWin(const AnsiString &Title, TStrings *Lines);
//---------------------------------------------------------------------------
extern TTextWin *TextWin;
//---------------------------------------------------------------------------
#endif
