//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "OpenDlg.h"
#include "SaveDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "NNameDlg.h"
#include "MsgWin.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpenForm *OpenForm;
//---------------------------------------------------------------------------
AnsiString __fastcall OpenOpenDlg(TStrings *Message, AnsiString &Section)
{
   AnsiString title;
   OpenForm = new TOpenForm(Application->MainForm);
   OpenForm->Init(Section);
   OpenForm->mode = "Open ";
   OpenForm->ShowModal();
   if (OpenForm->ModalResult==mrOk)
   {
      Section = OpenForm->DatSection();
      Message->Clear(); Sleep(SleepTime);
      GetAppData(Message,Section+PS+OpenForm->Name->Text);
      title = OpenForm->Name->Text;
   }
   delete OpenForm;
   return title;
}
//---------------------------------------------------------------------------
__fastcall TOpenForm::TOpenForm(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   ListBox->MultiSelect = true;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::Init(AnsiString &Section)
{
   if (Section!=MailQueue && Section!=ProblemQueue && Section!=SMTPLog && Section!=POP3Log)
   {
      LookInBox->Items->Add(UserNotes);
      LookInBox->Items->Add(UserMessages);
      LookInBox->Items->Add(UserTemplates);
      LookInBox->Items->Add(UserData);
   }
   else
      ListBox->Columns = 0;
   if (Section!=SMTPLog && Section!=POP3Log) // no extra lookinbox items for pop and smtp
   {
      if (AppDataExists(MailQueue)) LookInBox->Items->Add(MailQueue);
      if (AppDataExists(ProblemQueue)) LookInBox->Items->Add(ProblemQueue);
   }
   else
   {
      LookInBox->Items->Add(Section);
      ListBox->Font->Name = "Courier New";
      ListBox->Font->Size = 9;
   }
   LookInBox->ItemIndex = LookInBox->Items->IndexOf(Section);
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxClick(TObject *Sender)
{
   int count = ListBox->SelCount;
   bool multi = count>1;
   OkBtn->Enabled = count;
   Name->Enabled = !multi;
   if (!multi && ListBox->Items->Count)
      Name->Text = ListBox->Items->Strings[ListBox->ItemIndex];
   else
      Name->Clear();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOpenForm::Title()
{
   if (DatSection()==UserMailboxes) return "Mailbox";
   if (DatSection()==UserData) return "Data";
   if (DatSection()==UserTemplates) return "Template";
   if (DatSection()==UserMessages) return "Message";
   if (DatSection()==MailQueue) return "Message";
   if (DatSection()==ProblemQueue) return "Problem";
   if (DatSection()==SMTPLog) return SMTPLog;
   if (DatSection()==POP3Log) return POP3Log;
   if (DatSection()==UserNotes) return "Note";
   if (DatSection()==UserNyms) return "Nym";
   return "";
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::LoadItems()
{
   Name->Clear();
   Caption = mode+Title();
   ListBox->Items->Clear();
   TStringList *tmp = new TStringList();
   GetAppData(ListBox->Items,DatSection());
   ListBox->Items->AddStrings(tmp);
   if (ListBox->Items->Count)
      ListBox->ItemIndex = 0;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxDblClick(TObject *Sender)
{
   if (ListBox->SelCount==1) ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
   int pos;
   TRect r(Rect);
   ListBox->Canvas->FillRect(r);
   r.Right -= 4;
   AnsiString str=ListBox->Items->Strings[Index],fs=FieldSep;
   // fixup new style indexstr's with FieldSep dividers
   if (DatSection()==ProblemQueue || DatSection()==MailQueue)
   {

      while ((pos=str.Pos(InCode))>0) str.Delete(pos,2);
      while ((pos=str.Pos(OutCode))>0) str.Delete(pos,2);
      pos=1; while (pos<=str.Length())
      {
         if (str[pos]==fs[1])
         {
            str.Delete(pos,1); str.Insert("    ",pos);
         }
         pos++;
      }
      while (str.Length() && str[str.Length()]!=' ') // remove msg size field
         str.SetLength(str.Length()-1);
   }
   ListBox->Canvas->TextRect(r,r.Left+4, r.Top+2, str);
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopupMenuPopup(TObject *Sender)
{
   int c=0;
   for (int i=0; i<ListBox->Items->Count; i++)
      if (ListBox->Selected[i]) c++;
   PopRenameItem->Enabled = c==1;
   PopDeleteItems->Enabled = c>0;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopDeleteItemsClick(TObject *Sender)
{
   int i;
   AnsiString name;
   if (MsgBoxHwnd(Handle,"Delete selected "+Title()+"(s)!\n\nAre you sure?",
          "Delete Message",MB_OKCANCEL)==IDOK)
   {
      for (i=0; i<ListBox->Items->Count; i++)
         if (ListBox->Selected[i])
            PutAppData(DatSection()+PS+ListBox->Items->Strings[i],NULL);
      if (DatSection()==ProblemQueue) Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
      if (DatSection()==MailQueue) Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
   }
   LoadItems();
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopRenameItemClick(TObject *Sender)
{
   int i;
   AnsiString Newname,Oldname,name;
   for (i=0; i<ListBox->Items->Count; i++) {
      if (ListBox->Selected[i]) {
         Oldname = ListBox->Items->Strings[i];
         break;
      }
   }
   if (Oldname.IsEmpty()) return;

   if ((Newname=GetNewItemName(Oldname,"Rename "+Title(),DatSection()))!="")
   {
      if (Newname==Oldname) return;

      TStringList *menuboxes = new TStringList();
      delete menuboxes;

      Cursor = crHourGlass;
      TStringList *mail = new TStringList();
      GetAppData(mail,DatSection()+PS+Oldname);
      PutAppData(DatSection()+PS+Oldname,NULL);
      PutAppData(DatSection()+PS+Newname,mail);
      delete mail;
      LoadItems();
      Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   // do these before cancel as messages/problems may have been deleted
   if (DatSection()==ProblemQueue) Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
   if (DatSection()==MailQueue) Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
   if (ModalResult==mrCancel) return;

   // can't exit ok with empty name
   if (Name->Text.IsEmpty()) {
      MyBeep(MB_OK);
      CanClose = false;
      return;
   }
   // is the name supplied in the list?
   if (ListBox->Items->IndexOf(Name->Text)<0)
   {
      MsgBoxHwnd(Handle,"Invalid Name!\n\nPlease select from the list supplied.","Open Error",MB_OK);
      Name->Clear();
      ActiveControl = Name;
      CanClose = false;
      return;
   }
   // is this the master list of data section?
   if (DatSection()==UserData)
   {
      AnsiString tmp;
      if (ListBox->ItemIndex>=0)
         tmp = ListBox->Items->Strings[ListBox->ItemIndex];
      LookInBox->ItemIndex = LookInBox->Items->IndexOf(tmp);
      LoadItems();
      CanClose = false;
      return;
   }
   // exit ok--no problems
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::LookInBoxChange(TObject *Sender)
{
   if (LookInBox->Text==UserData)
   {
      ListBox->Clear();
      Caption = mode+Title();
      if (AppDataExists(ProblemQueue)) ListBox->Items->Add(ProblemQueue);
      if (AppDataExists(MailQueue)) ListBox->Items->Add(MailQueue);
      if (AppDataExists(UserNyms)) ListBox->Items->Add(UserNyms);
      ListBox->Items->Add(UserTemplates);
      ListBox->Items->Add(UserMessages);
      ListBox->Items->Add(UserNotes);
   }
   else
      LoadItems();
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::FormShow(TObject *Sender)
{
   LookInBoxChange(Sender);
   if (DatSection()==SMTPLog || DatSection()==POP3Log)
   {
      int index = ListBox->Items->Count-5; if (index<0) index = 0;
      //ListBox->ItemIndex = ListBox->Items->Count-1;
      ListBox->TopIndex = index;
      ListBox->PopupMenu = NULL;
   }
}
//---------------------------------------------------------------------------
