#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PopAccDlg.h"
#include "PopProfDlg.h"
#include "PopRetDlg.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma link "Pop3Prot"
#pragma resource "*.dfm"
TPopAcctDlg *PopAcctDlg;
//---------------------------------------------------------------------------
__fastcall TPopAcctDlg::TPopAcctDlg(TComponent* Owner)
  : TForm(Owner)
{
   accts = new TStringList();
   acct = new TStringList();
   MainForm = (TForm*)Owner;
   modified = false;
   index = -1;
}
//---------------------------------------------------------------------------
__fastcall TPopAcctDlg::~TPopAcctDlg()
{
   delete acct;
   delete accts;
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Checked()
{
   return acct->Values["checked"]=="1";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopAcctDlg::Password()
{
   return acct->Values["password"];
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopAcctDlg::Account()
{
   return acct->Values["account"];
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Remember()
{
   return acct->Values["remember"]=="1";
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::Delete()
{
   return acct->Values["delete"]=="1";
}
//---------------------------------------------------------------------------
bool __fastcall TPopAcctDlg::PgpOnly()
{
   return acct->Values["pgponly"]=="1";
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::LoadAcct(int Index)
{
   if (Index<0 || Index>accts->Count-1) return;
   acct->Clear();
   AnsiString item,s=accts->Strings[Index];
   int i=0; while ((item=GetParam(i++,s,"\255"))!="")
      acct->Add(item);
   index = Index;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::DrawCheck(TCanvas *Canvas, TRect &Rect, TColor Color)
{
   TColor color = Canvas->Pen->Color;
   Canvas->Pen->Color = Color;
   Canvas->MoveTo(Rect.Left+4,Rect.Top+8);
   Canvas->LineTo(Rect.Left+7,Rect.Top+11);
   Canvas->LineTo(Rect.Left+16,Rect.Top+2);
   Canvas->MoveTo(Rect.Left+4,Rect.Top+9);
   Canvas->LineTo(Rect.Left+7,Rect.Top+12);
   Canvas->LineTo(Rect.Left+16,Rect.Top+3);
   Canvas->Pen->Color = color;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   if (index!=Index) LoadAcct(Index);
   AcctsDrawItemCanvas(Accts->Canvas, Index, Rect, State);
 }
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDrawItemCanvas(TCanvas *Canvas, int Index,
   TRect &Rect, TOwnerDrawState State)
{
  AnsiString text;
  for (int col=0; col<3; col++)
   {
      switch (col)
      {
         case 0:
            text = "";
            Canvas->TextRect(Rect,Rect.Left,Rect.Top+1,text);
            if (Checked())
               DrawCheck(Canvas,Rect,State.Contains(odSelected)?clWhite:clBlue);
            break;
         case 1:
            Rect.Left = 27;
            Canvas->TextRect(Rect,Rect.Left,Rect.Top+1,Remember()?"x ":"  ");
            Rect.Left += 11;
            Canvas->TextRect(Rect,Rect.Left,Rect.Top+1,Delete()?"x ":"  ");
            Rect.Left += 11;
            Canvas->TextRect(Rect,Rect.Left,Rect.Top+1,PgpOnly()?"x ":"  ");
            break;
         case 2:
            Rect.Left = 69;
            text = Account();
            Canvas->TextRect(Rect,Rect.Left,Rect.Top+1,text);
            break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::HeaderControl1DrawSection(
  THeaderControl *HeaderControl, THeaderSection *Section, const TRect &Rect,
  bool Pressed)
{
   TRect rect(Rect); rect.Top += 2;
   DrawCheck(HeaderControl->Canvas,rect,clBlack);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsMouseDown(TObject *Sender, TMouseButton Button,
   TShiftState Shift, int X, int Y)
{
   LastMouse.x = X; LastMouse.y = Y;
   if (X>=69) return; // not an area for special processing

   LoadAcct(Accts->ItemIndex);
   TRect r = Accts->ItemRect(Accts->ItemIndex);
   if (Y<r.Top || Y>r.Bottom) return; // not this row

   //LockWindowUpdate(Handle);
   if (X>=0  && X<24)
   {
      acct->Values["checked"] = Checked() ? "0":"1";
      r.Left = 0; r.Right = 23;
      modified = true;
   }
   else
   if (X>=27 && X<35)
   {
      if (Remember())
      {
          if (MsgBoxHwnd(Handle,"Forget password now?","Password",MB_OKCANCEL)==IDOK)
          {
             acct->Values["remember"] = "0";
             acct->Values["password"] = "";
             modified = true;
          }
      }
      else
      {
         MsgBoxHwnd(Handle,"No password to remember!","Password",MB_OK);
      }
      //acct->Values["Remember"] = Remember() ? "0":"1";
      r.Left = 27; r.Right = 34;
   }
   else
   if (X>=38 && X<46)
   {
      acct->Values["delete"] = Delete() ? "0":"1";
      r.Left = 38; r.Right = 45;
      modified = true;
   }
   else
   if (X>=49 && X<57)
   {
      acct->Values["pgponly"] = PgpOnly() ? "0":"1";
      r.Left = 49; r.Right = 68;
      modified = true;
   }
   SaveAcct();
   InvalidateRect(Accts->Handle,&RECT(r),false);
   LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::SaveAcct()
{
   AnsiString text;
   for (int i=0; i<acct->Count; i++)
      if (i<acct->Count-1) text += acct->Strings[i]+"\255";
   if (Accts->ItemIndex>=0)
      accts->Strings[Accts->ItemIndex] = text;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsKeyPress(TObject *Sender, char &Key)
{
   if (Accts->ItemIndex>=0 && Key==' ')
   {
      LoadAcct(Accts->ItemIndex);
      acct->Values["Checked"] = Checked() ? "0":"1";
      SaveAcct();
      TRect r = Accts->ItemRect(Accts->ItemIndex); r.Right = 23;
      InvalidateRect(Accts->Handle,&RECT(r),false);
      OkBtn->Enabled = CheckCount();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsClick(TObject *Sender)
{
   AcctUp->Enabled = accts->Count>1;
   AcctDn->Enabled = accts->Count>1;
   bool idx = Accts->ItemIndex;
   DeleteBtn->Enabled = idx>=0;
   EditBtn->Enabled = idx>=0;
   LastItem = idx;
   OkBtn->Enabled = CheckCount();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::HeaderControl1SectionClick(
  THeaderControl *HeaderControl, THeaderSection *Section)
{
   if (Section->Text=="Check") AcctsKeyPress(NULL,' ');
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::NewBtnClick(TObject *Sender)
{
   AnsiString profile = NewAcctProfile(this);
   if (!profile.IsEmpty())
   {
      accts->Add(profile); SyncAccts();
      Accts->Invalidate();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::EditBtnClick(TObject *Sender)
{
   int idx=Accts->ItemIndex; if (idx<0) return;
   AnsiString profile = EditAcctProfile(this,accts->Strings[idx]);
   if (!profile.IsEmpty())
   {
      accts->Strings[idx] = profile; SyncAccts();
      RECT r; SetRect(&r,0,0,Accts->Width,Accts->Height);
      InvalidateRect(Accts->Handle,&r,false);
      ActiveControl = Accts;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::DeleteBtnClick(TObject *Sender)
{
   if (Accts->ItemIndex<0) return;
   if (MsgBoxHwnd(Handle,"Delete '"+Account()+"' ?\n\n Are you sure?","Delete Account",MB_OKCANCEL)==IDOK)
   {
      TOwnerDrawState state;
      accts->Delete(Accts->ItemIndex); SyncAccts();
      // draw the list--can't seem to get it redrawn correctly otherwise
      // this works here but not above...HERE the _whole_ box is white
      for (int i=0; i<accts->Count; i++)
      {
         TRect r = Accts->ItemRect(i);
         AcctsDrawItem(Accts, i, r, state);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::SyncAccts()
{
   // remove null lines from end of actual array (accts)
   if (accts->Count)
   {
      while (accts->Strings[accts->Count-1].LowerCase().Pos("checked")!=1)
         accts->Delete(accts->Count-1);
      // if Accts has more lines than accts, delete from Accts
      while (Accts->Items->Count && Accts->Items->Count > accts->Count)
         Accts->Items->Delete(0);
      // if accts has more lines than Accts, add to Accts
      while (Accts->Items->Count < accts->Count)
         Accts->Items->Add("");
   }
   switch (accts->Count)
   {
      case 0:
         Label1->Caption = "You currently have no active Pop3 accounts. Click 'New...' to create one.";
         AcctUp->Visible = false; AcctDn->Visible = false;
         break;
      case 1:
         Label1->Caption = "";
         AcctUp->Visible = false; AcctDn->Visible = false;
         break;
      default:
         Label1->Caption = "Click 'check' column to mark/unmark for download.";
         AcctUp->Visible = true; AcctDn->Visible = true;
         break;
   }
   OkBtn->Enabled = CheckCount();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::OkBtnClick(TObject *Sender)
{
   TStringList *tmp = new TStringList();
   for (int i=0; i<accts->Count; i++)
   {
      AnsiString acc=accts->Strings[i];
      if (acc.LowerCase().Pos("checked=1"))
         tmp->Add(acc);
   }
   if (!tmp->Count)
   {
      MsgBoxHwnd(Handle,"No accounts are marked for retreive!","Check Mail Problem",MB_OKCANCEL);
      return;
   }
   //Hide();
   PopRetrieveMail(tmp,this,MainForm);
   delete tmp;
   //ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopGetThisItemClick(TObject *Sender)
{
   if (Accts->ItemIndex<0) return;

   TStringList *tmp = new TStringList();
   tmp->Add(accts->Strings[Accts->ItemIndex]);
   //Hide();
   PopRetrieveMail(tmp,this,MainForm);
   //ModalResult = mrOk;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopupMenuPopup(TObject *Sender)
{
   int c = CheckCount(),i=Accts->ItemIndex;
   PopGetMailItem->Enabled = c>0;
   PopGetThisItem->Enabled = i>=0;
   PopToggleItem->Enabled = i>=0;
   if (i>=0)
   {
      LoadAcct(i);
      if (!Checked()) PopToggleItem->Caption="Mark account";
      else PopToggleItem->Caption = "Un&mark account";
      Accts->Invalidate();
      SaveAcct();
   }
}
//---------------------------------------------------------------------------
int  __fastcall TPopAcctDlg::CheckCount()
{
   int c=0; for (int i=0; i<accts->Count; i++)
       if (accts->Strings[i].LowerCase().Pos("checked=1"))
          c++;
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::PopToggleItemClick(TObject *Sender)
{
   acct->Values["checked"]=Checked()?"0":"1"; SaveAcct();
   Accts->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctDnClick(TObject *Sender)
{
   int idx=Accts->ItemIndex;
   if (idx<accts->Count-1)
   {
      accts->Add("");
      AnsiString s = accts->Strings[idx];
      accts->Delete(idx);
      accts->Insert(idx+1,s);
      accts->Delete(accts->Count-1);
      Accts->ItemIndex++;
      Accts->Invalidate();
   }
   else MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctUpClick(TObject *Sender)
{
   int idx=Accts->ItemIndex;
   if (idx>0)
   {
      AnsiString s = accts->Strings[idx];
      accts->Delete(idx);
      accts->Insert(idx-1,s);
      Accts->ItemIndex--;
      Accts->Invalidate();
   }
   else MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::AcctsDblClick(TObject *Sender)
{
   if (LastMouse.x>69) EditBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPopAcctDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
//
}
//---------------------------------------------------------------------------
