//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RelEditDlg.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFileListDlg *FileListDlg;
//---------------------------------------------------------------------------
__fastcall TFileListDlg::TFileListDlg(TComponent* Owner)
  : TForm(Owner)
{
   files = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::GetFileNames(bool filter)
{
  LockWindowUpdate(Handle);
  ListBox->Clear();
  for (int i=0; i<files->Count; i++)
  {
     if (filter && ExtractFileExt(files->Strings[i])==".exe")
        continue;
     ListBox->Items->Add(files->Strings[i]);
  }
  LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::ListBoxClick(TObject *Sender)
{
   int idx = ListBox->ItemIndex;
   if (idx>=0)
   {
      AnsiString file = ListBox->Items->Strings[idx];
      OkBtn->Enabled = FileExists(file) && ExtractFileExt(file)!=".exe";
   }
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::ListBoxDblClick(TObject *Sender)
{
   if (OkBtn->Enabled) ModalResult = mrOk;   
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::FilterBoxClick(TObject *Sender)
{
   GetFileNames(FilterBox->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   delete files;
}
//---------------------------------------------------------------------------
void __fastcall TFileListDlg::FormShow(TObject *Sender)
{
   GetFileNames(FilterBox->Checked);
}
//---------------------------------------------------------------------------