//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "ReleaseU.h"
#include "FileMan.h"
#include "HeadMan.h"
#include "Version.h"
#include "Global.h"
#include "MsgWin.h"
#include "DirBrow.h"
#include "RelEditDlg.h"
#include "RunConsole.h"
#include "Console.h"
//---------------------------------------------------------------------------
#pragma link "zlib.lib"
#pragma resource "*.dfm"
TIniForm *IniForm;
//---------------------------------------------------------------------------
__fastcall TIniForm::TIniForm(TComponent* Owner)
  : TForm(Owner)
{
   IniStore->Clear();
   Memo1->Clear();
   Memo2->Clear();
   Memo3->Clear();
   Memo5->Clear();
   Copied->Clear();
   Comped->Clear();
   pages = PageControl1->PageCount;
   page = 0;
   PageControl1->ActivePage = Start;
   ActiveControl = NextBtn;
   TStringList *ini = new TStringList();
   GetAppData(ini,"Initialization");
   AppMak->Text = ini->Values["Makefile"];
   DestDir->Text = ini->Values["DestDirectory"];
   Aspack->Text = ini->Values["Aspack"];
   AppName1->Text = ini->Values["AppName"];
   AppVer->Text = ini->Values["AppVer"];
   AppSubVer->Text = ini->Values["AppSubVer"];
   ArcPath->Text = ini->Values["ArcPath"];
   ZipFull->Text = ini->Values["ZipFull"];
   ZipRel->Text = ini->Values["ZipRel"];
   Version->Text = ini->Values["VerHeader"];
   MakePro->Text = ini->Values["MakeExe"];
   SelfExt->Text = ini->Values["SelfExt"];
   SEinput->Text = ini->Values["SEinput"];
   SEmsg->Text = ini->Values["SEmsg"];
   SEabout->Text = ini->Values["SEabout"];

   History->Text = ini->Values["HistoryTxt"];
   Readme->Text = ini->Values["ReadmeTxt"];
   License->Text = ini->Values["LicenseTxt"];
   Todo->Text = ini->Values["TodoTxt"];
   Quickstart->Text = ini->Values["QuickstartRtf"];

   delete ini;
   GetAppData(AppFiles->Lines,"CopyFiles");
   GetAppData(CompExes->Lines,"CompExes");
   GetAppData(CompProj->Lines,"CompProjects");
   GetAppData(IniStore->Lines,"IniStore");

   OpenVersionHBtn->Enabled = FileExists(Version->Text);
   OpenMakBtn->Enabled = FileExists(AppMak->Text);
//   SEinputBtn->Enabled = FileExists(SEinput->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
//   if (ModalResult==mrCancel) && MsgBox("Quit Release now?","Release",MB_YESNO)==IDNO)
//   {
//      CanClose = false;
//      return;
//   }
   TStringList *ini = new TStringList();
   ini->Values["Makefile"] = AppMak->Text;
   ini->Values["DestDirectory"] = DestDir->Text;
   ini->Values["Aspack"] = Aspack->Text;
   ini->Values["AppName"] = AppName1->Text;
   ini->Values["AppVer"] = AppVer->Text;
   ini->Values["AppSubVer"] = AppSubVer->Text;
   ini->Values["ArcPath"] = ArcPath->Text;
   ini->Values["ZipFull"] = ZipFull->Text;
   ini->Values["ZipRel"] = ZipRel->Text;
   ini->Values["VerHeader"] = Version->Text;
   ini->Values["MakeExe"] = MakePro->Text;
   ini->Values["SelfExt"] = SelfExt->Text;
   ini->Values["SEinput"] = SEinput->Text;
   ini->Values["SEmsg"] = SEmsg->Text;
   ini->Values["SEabout"] = SEabout->Text;
   ini->Values["HistoryTxt"] = History->Text;
   ini->Values["ReadmeTxt"] = Readme->Text;
   ini->Values["LicenseTxt"] = License->Text;
   ini->Values["TodoTxt"] = Todo->Text;
   ini->Values["QuickstartRtf"] = Quickstart->Text;
   PutAppData(AppIniValues,ini);
   delete ini;
   PutAppData("CopyFiles",AppFiles->Lines);
   PutAppData("CompExes",CompExes->Lines);
   PutAppData("CompProjects",CompProj->Lines);
   PutAppData("IniStore",IniStore->Lines);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::FormDestroy(TObject *Sender)
{
   //
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::PageControl1Change(TObject *Sender)
{
   int page = PageControl1->ActivePage->PageIndex;
   BackBtn->Enabled = page > 0;
   NextBtn->Enabled = page < pages-1;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::NextBtnClick(TObject *Sender)
{
   PageControl1->SelectNextPage(true);
   page = PageControl1->ActivePage->PageIndex;
   NextBtn->Enabled = page < pages-1;
   BackBtn->Enabled = page > 0;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BackBtnClick(TObject *Sender)
{
   PageControl1->SelectNextPage(false);
   page = PageControl1->ActivePage->PageIndex;
   NextBtn->Enabled = page < pages-1;
   BackBtn->Enabled = page > 0;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CancelBtnClick(TObject *Sender)
{
   ModalResult = mrCancel;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::StoreBtnClick(TObject *Sender)
{
   AnsiString path,link,ext,s,file,sbak,appIni=ChangeFileExt(AppExe,IniExt);
   if (FileExists(appIni)) DeleteFile(appIni.c_str());
 //StoreBtn->Enabled = false;
   int pos;

   TDataBuf *buf = new TDataBuf();
   for (int i=0; i<IniStore->Lines->Count; i++)
   {
      path = "";
      file = IniStore->Lines->Strings[i];
      if (file.SubString(1,1)=="-") continue;
      if (FileExists(file))
      {
         s = ExtractFileName(file); ext = s.SubString(s.Length()-3,4);
         if (ext.LowerCase()==".txt") s.Delete(s.Length()-3,4);
         sbak = s;
         while ((pos=s.Pos("_"))>0) { s.Insert(PS,pos); s.Delete(pos+1,1); }
         while ((pos=sbak.Pos("_"))>0) { sbak.Insert("\\",pos); sbak.Delete(pos+1,1); }
         if (s.Pos("BugReport"))
         {
            // add release version to the subject line of bugreport template
            TStringList *bug = new TStringList();
            HeadMan = new THeaderManager(bug);
            bug->LoadFromFile(file);
            int pos = HeadMan->Delete("Subject: ");
            if (pos>=0) bug->Insert(pos,"Subject: "+AppName+" "+ReleaseVer+"  Bug Report");
            bug->SaveToFile(file);
            delete HeadMan;
            delete bug;
         }
         buf->LoadFromFile(file);
         PutAppBinary(s,buf,appIni);
         Memo2->Lines->Add(sbak);
      }
      else
         MsgBox("File '"+file+"' does not exist!","File Error",MB_OK);
   }
   delete buf;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BrowAppBtnClick(TObject *Sender)
{
   OpenDialog1->DefaultExt = "mak";
   OpenDialog1->FileName = "*.mak";
   if (OpenDialog1->Execute()) AppMak->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   if (!FileExists(AppMak->Text))
      MsgBox("Application makefile is missing!","Release Error",MB_OK);
}
//---------------------------------------------------------------------------
AnsiString __fastcall getfile(AnsiString &line)
{
   int end = 0;
   for (int i=1; i<=line.Length(); i++)
      if (line[i]==' ' || line[i]=='\t')
      {
         end = i-1; break;
      }
   if (!end) end = line.Length();
   return line.SubString(1,end);
}
//---------------------------------------------------------------------------
AnsiString __fastcall getnewname(AnsiString &line)
{
   int start=0,fend = getfile(line).Length();
   for (int i=fend+1; i<=line.Length(); i++)
      if (line[i]!=' ' && line[i]!='\t')
      {
         start = i; break;
      }
   if (!start) start++;
   return line.SubString(start,line.Length());
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CopyFilesBtnClick(TObject *Sender)
{
   AnsiString path,file,name,newdir,
      olddir = ExtractFilePath(AppMak->Text);
   // check to see source names exist
   for (int i=0; i<AppFiles->Lines->Count; i++)
   {
      file = GetParam(0,AppFiles->Lines->Strings[i],"\t");//getfile(AppFiles->Lines->Strings[i]);
      if (file.SubString(1,1)=="-") continue;
      if (!FileExists(olddir+file))
      {
         MsgBox("File '"+olddir+file+"' is missing!","Copy File Error",MB_OK);
         return;
      }
   }
   AnsiString dest = DestDir->Text;
   if (!DirectoryExists(DestDir->Text))
      ForceDirectories(dest);
   else
   {  // clear destination dir
      TStringList *files = new TStringList();
      GetFilenames(files,AddBackslash(dest)+"*.*");
      for (int i=0; i<files->Count; i++) DeleteFile(files->Strings[i].c_str());
      delete files;
   }
   // copy files
   for (int i=0; i<AppFiles->Lines->Count; i++)
   {
      newdir = AddBackslash(dest);
      file = AppFiles->Lines->Strings[i];
      if (file.SubString(1,1)=="-") continue;
      
      name = GetParam(0,file,"\t").Trim();
      path = GetParam(1,file,"\t").Trim();
      newdir = path.IsEmpty() ? AddBackslash(dest) : AddBackslash(olddir+path);
      if ( FileExists(newdir+name)) remove(AnsiString(newdir+name).c_str());
      if (!DirectoryExists(newdir)) ForceDirectories(newdir);
      TMemoryStream *ms = new TMemoryStream();
      ms->LoadFromFile(olddir+name);
      ms->SaveToFile(newdir+ExtractFileName(name));
      delete ms;
      Copied->Lines->Add(name+"\t"+path);
      //Copied->SelStart = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Button1Click(TObject *Sender)
{
   ExploreFolder(DestDir->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::PackBtnClick(TObject *Sender)
{
   AnsiString file,destdir = AddBackslash(DestDir->Text);
   if (!FileExists(Aspack->Text))
   {
      MsgBox("Packing program: \n"+Aspack->Text+"\n is missing!","File Missing error",MB_OK);
      return;
   }
   for (int i=0; i<CompExes->Lines->Count; i++)
   {
      file = CompExes->Lines->Strings[i];
      if (file.SubString(1,1)=="-") continue;
      if (!FileExists(destdir+file))
      {
         MsgBox("File '"+file+"' is missing!","Missing File Error",MB_OK);
         return;
      }
   }
   for (int i=0; i<CompExes->Lines->Count; i++)
   {
      file = CompExes->Lines->Strings[i];
      if (file.SubString(1,1)=="-") continue;

      ExecAndWait95(Aspack->Text+" "+destdir+file);
      Comped->Lines->Add(file);
      Application->ProcessMessages();
      Sleep(500);
   }
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Button3Click(TObject *Sender)
{
   AnsiString path = GetDirectoryPath(this);
   if (path != "cancel") ArcPath->Text = path;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BrowDestBtnClick(TObject *Sender)
{
   AnsiString path = GetDirectoryPath(this);
   if (path != "cancel") DestDir->Text = path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall InsertText(const AnsiString &inTextStr, const AnsiString &FindStr,
   const AnsiString &ReplaceStr)
{
   AnsiString str = inTextStr;
   int pos = str.Pos(FindStr);
   if (pos) {
      str.Insert(ReplaceStr,pos);
      str.Delete(pos+ReplaceStr.Length(),FindStr.Length());
   }
   return str;
}
void __fastcall TIniForm::ZipperBtnClick(TObject *Sender)
{
   AnsiString apath = ArcPath->Text;
   if (!DirectoryExists(apath)) ForceDirectories(apath);
   if (!DirectoryExists(apath))
   {
      MsgBox("Unable to create directory:\n"+apath,"Create Directory Error",MB_OK);
      return;
   }

   TStringList *dels = new TStringList();
   GetFilenames(dels,AddBackslash(DestDir->Text)+"*.bak");
   for (int i=0; i<dels->Count; i++)
      DeleteFile(dels->Strings[i].c_str());
   delete dels;

   AnsiString zipcmd,name;
   AnsiString arcdir = AddBackslash(ArcPath->Text);
   if (ZipAllBox->Checked)
   {
      zipcmd = ZipFull->Text;
      name = ExtractFileName(AppMak->Text);
      name = arcdir+name.SubString(1,name.Length()-4)+AppVer->Text+AppSubVer->Text+"src.zip";
      if (FileExists(name)) DeleteFile(name.c_str());
      zipcmd = InsertText(zipcmd,"%s",name);
      RunConsoleAppRelease(zipcmd);
    //ExecAndWait95(zipcmd);
      AnsiString shtname = ExtractFileName(name);
      if (!FileExists(name)) shtname += " <failed>";
      Memo3->Lines->Add(shtname);
      for (int i=0; i<10; i++)
      {
         Application->ProcessMessages();
         Sleep(100);
      }
   }

   if (ZipRelBox->Checked)
   {
      zipcmd = ZipRel->Text;
      name = ExtractFileName(AppMak->Text).UpperCase();
      name = arcdir+name.SubString(1,name.Length()-4)+AppVer->Text+AppSubVer->Text+".zip";
      if (FileExists(name)) DeleteFile(name.c_str());

      zipcmd = InsertText(zipcmd,"%s",name);
      zipcmd = InsertText(zipcmd,"%packdir%",AddBackslash(DestDir->Text));
      RunConsoleAppRelease(zipcmd);
    //ExecAndWait95(zipcmd);
      AnsiString shtname = ExtractFileName(name);
      if (!FileExists(name)) shtname += " <failed>";
      Memo3->Lines->Add(shtname);
      for (int i=0; i<10; i++)
      {
         Application->ProcessMessages();
         Sleep(100);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::ShowRelDirClick(TObject *Sender)
{
   ExploreFolder(ArcPath->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::ZipAllBoxClick(TObject *Sender)
{
   ZipFull->Enabled = ZipAllBox->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::ZipRelBoxClick(TObject *Sender)
{
   ZipRel->Enabled = ZipRelBox->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CompileBtnClick(TObject *Sender)
{
   if (!FileExists(Version->Text))
   {
      MsgBox("The file '"+Version->Text+"' is missing!","File Error",MB_OK);
      return;
   }

   AnsiString s,exe;
   bool gotname=false, gotver=false;
   AnsiString appnameline = "const AnsiString AppName(\"";
   AnsiString relversline = "const AnsiString ReleaseVer(\"";
   TStringList *version = new TStringList();
   version->LoadFromFile(Version->Text);
   for (int i=0; i<version->Count; i++)
   {
      s = version->Strings[i];
      if (s.SubString(1,appnameline.Length())==appnameline)
      {
         version->Strings[i] = appnameline+AppName1->Text+"\");";
         gotname = true;
      }
      if (s.SubString(1,relversline.Length())==relversline)
      {
         AnsiString ver = AppVer->Text+AppSubVer->Text;
         if (ver[1]=='0') ver[1] = '.';
         version->Strings[i] = relversline+ver+"\");";
         gotver = true;
      }
      if (gotname && gotver)
         break;
   }
   version->SaveToFile(Version->Text);
   delete version;
   for (int i=0; i<CompProj->Lines->Count; i++)
   {
      s = CompProj->Lines->Strings[i];
      if (s.SubString(1,1)=="-") continue;

      exe = ChangeFileExt(s,".exe");
      if (FileExists(exe)) DeleteFile(exe.c_str());

      RunConsoleAppRelease(MakePro->Text+" -B -f"+s);
      //ExecAndWait95(MakePro->Text+" -B -f"+s);
      if (!FileExists(exe)) s += " <failed>";
      for (int c=0; c<10; c++)
      {
         Application->ProcessMessages();
         Sleep(100);
      }
      Application->ProcessMessages();
      Sleep(500);
      Memo5->Lines->Add(ChangeFileExt(s,".exe"));
   }
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::ShowAppDirBtnClick(TObject *Sender)
{
   ExploreFolder(ExtractFilePath(AppMak->Text));
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BrowseMakeBtnClick(TObject *Sender)
{
   OpenDialog1->DefaultExt = "exe";
   OpenDialog1->FileName = "*.exe";
   if (OpenDialog1->Execute()) MakePro->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BrowAspackBtnClick(TObject *Sender)
{
   OpenDialog1->DefaultExt = "exe";
   OpenDialog1->FileName = "*.exe";
   if (OpenDialog1->Execute()) Aspack->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::BrowVersionHBtnClick(TObject *Sender)
{
   OpenDialog1->DefaultExt = "h";
   OpenDialog1->FileName = "*.h";
   if (OpenDialog1->Execute()) Version->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::OpenVersionHBtnClick(TObject *Sender)
{
   if (FileExists(Version->Text))
      Exec95("notepad.exe "+Version->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::VersionChange(TObject *Sender)
{
   OpenVersionHBtn->Enabled = FileExists(Version->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::OpenMakBtnClick(TObject *Sender)
{
   if (FileExists(AppMak->Text)) Exec95("notepad.exe "+AppMak->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::AppMakChange(TObject *Sender)
{
   OpenMakBtn->Enabled = FileExists(AppMak->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Memo5DblClick(TObject *Sender)
{
   Memo5->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CopiedDblClick(TObject *Sender)
{
   Copied->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Memo2DblClick(TObject *Sender)
{
   Memo2->Clear();  
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CompedDblClick(TObject *Sender)
{
   Comped->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Memo3DblClick(TObject *Sender)
{
   Memo3->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::CreateSEBtnClick(TObject *Sender)
{
   int pos;
   AnsiString arcdir = AddBackslash(ArcPath->Text);
   AnsiString zipname = ExtractFileName(AppMak->Text);
   zipname = arcdir+ChangeFileExt(zipname,"")+AppVer->Text+AppSubVer->Text+".zip";
   AnsiString exename = ChangeFileExt(zipname,".exe");
   AnsiString signame = exename+".sig";
   if (FileExists(signame)) DeleteFile(signame.c_str());

   AnsiString appver = AppVer->Text; if (appver[1]=='0') appver[1] = '.';
   AnsiString appnamever = AppName1->Text+" "+appver+AppSubVer->Text;
   AnsiString secmd = SelfExt->Text;
   pos = secmd.Pos("%s");
   if (pos)
   {
      secmd.Insert(zipname,pos);
      secmd.Delete(pos+zipname.Length(),2);
   }

   AnsiString cmd;
   TStringList *bak = new TStringList();
   TStringList *cmds = new TStringList();
   cmds->LoadFromFile(SEinput->Text);
   for (int i=0; i<cmds->Count; i++)
   {
      cmd = cmds->Strings[i];
      if (cmd.SubString(1,3)=="-st") cmd = "-st \""+appnamever+"\"";
      cmds->Strings[i] = cmd;
   }
   cmds->SaveToFile(SEinput->Text);
   // the AboutBox file...
   bak->LoadFromFile(SEabout->Text);
   cmds->LoadFromFile(SEabout->Text);
   cmds->Add("");
   cmds->Insert(0,"\n"+appnamever+"\n"+CopyRight);
   while (cmds->Strings[cmds->Count-1].IsEmpty())
      cmds->Delete(cmds->Count-1);
   cmds->SaveToFile(SEabout->Text);
   ExecAndWait95(secmd);
   bak->SaveToFile(SEabout->Text);
   delete cmds;
   delete bak;

   exename = ExtractFileName(exename);
   if (!FileExists(arcdir+exename)) exename += " <failed>";
   Memo1->Lines->Add(exename);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Memo1DblClick(TObject *Sender)
{
   Memo1->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::SEinputBtnClick(TObject *Sender)
{
   Exec95("notepad.exe "+SEinput->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::SpeedButton1Click(TObject *Sender)
{
   Exec95("notepad.exe "+SEmsg->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::SpeedButton2Click(TObject *Sender)
{
   Exec95("notepad.exe "+SEabout->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::Open1Click(TObject *Sender)
{
   AnsiString file;
   if (Memo1->SelLength>0) file = Memo1->SelText.Trim(); else
   if (CompProj->SelLength>0) file = CompProj->SelText.Trim(); else
   if (AppFiles->SelLength>0) file = AppFiles->SelText.Trim();
   if (FileExists(file)) Exec95("notepad.exe "+file);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::FListBtnClick(TObject *Sender)
{
   AnsiString s;
   FListBtn->Enabled = false;
   FileListDlg = new TFileListDlg(this);
   CenterDialog(FileListDlg,this);
   TStringList *files = FileListDlg->files;
   files->AddStrings(IniStore->Lines);
   files->AddStrings(CompProj->Lines);
   files->AddStrings(AppFiles->Lines);
   files->Add(Version->Text);
   files->Add(SEinput->Text);
   files->Add(SEmsg->Text);
   files->Add(SEabout->Text);
   files->Sorted = true;
//   FileListDlg->ListBox->Sorted = true;
//   FileListDlg->ListBox->ItemIndex = 0;
   FileListDlg->ShowModal();
   if (FileListDlg->ModalResult==mrOk)
   {
      s = FileListDlg->ListBox->Items->Strings[FileListDlg->ListBox->ItemIndex];
      if (ExtractFileExt(s)==".rtf")
         Exec95("c:\\progra~1\\access~1\\wordpad.exe "+s);
      else
         Exec95("notepad.exe "+s);
   }
   delete FileListDlg;
   FListBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::HistoryBtnClick(TObject *Sender)
{
   Exec95(History->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::ReadmeBtnClick(TObject *Sender)
{
   Exec95(Readme->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::LicenseBtnClick(TObject *Sender)
{
   Exec95(License->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::TodoBtnClick(TObject *Sender)
{
   Exec95(Todo->Text);
}
//---------------------------------------------------------------------------
void __fastcall TIniForm::QuickstartBtnClick(TObject *Sender)
{
   Exec95(Quickstart->Text);
}
//---------------------------------------------------------------------------
